﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Browser;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Resources;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    
    public partial class MainPage : UserControl
    {
         
        string strFileDir = "";
        string strFileList = "";
        
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnBrowseFolder_Click(object sender, RoutedEventArgs e)
        {
            //选择目录
            strFileDir = HtmlPage.Window.Invoke("browseFolder", "Invoke").ToString();
            strFileList = HtmlPage.Window.Invoke("getFileList", "Invoke").ToString();
           
            if (string.IsNullOrEmpty(strFileDir))
            {
                MessageBox.Show("请选择保存位置。");
                return;
            }
            if (string.IsNullOrEmpty(strFileList))
            {
                MessageBox.Show("获取文件列表失败。");
                return;
            }

            string uri = Application.Current.Host.Source.AbsoluteUri;
            int index = uri.IndexOf("/ClientBin");
            uri = uri.Substring(0, index) + "/test.zip";

            WebClient webClient = new WebClient();
            webClient.OpenReadCompleted += new OpenReadCompletedEventHandler(webClient_OpenReadCompleted);
            webClient.DownloadProgressChanged += new DownloadProgressChangedEventHandler(webClient_DownloadProgressChanged);
            webClient.OpenReadAsync(new Uri(uri));

        }

      
        void webClient_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            //TODO:显示进度

        }
        public void webClient_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                Stream zipStream = e.Result;
                foreach (string f in strFileList.Split(','))
                {
                    if (f.IndexOf(".") > 0)
                    {
                        
                        SaveFileFromStream(f, zipStream);
                    }
                    
                }
                zipStream.Close();
                MessageBox.Show("下载完成。");
            }
            
        }
        public void SaveFileFromStream(string fileName, Stream zipStream)
        {
            Uri uri = new Uri(fileName, UriKind.Relative);
            StreamResourceInfo zipPackageSri = new StreamResourceInfo(zipStream, null);
            StreamResourceInfo textSri = Application.GetResourceStream(zipPackageSri, uri);

            Stream stream = textSri.Stream;

            byte[] arrayByte = new byte[1024];
            int imgLong = (int)stream.Length;
            int l = 0;
            /*
            操作本地磁盘是需要silverlight可以在浏览器内完全受信任运行特性的
            部署时，需要修改客户端注册表或者设置xap文件的域管理员证书,详情请看下面链接
            http://www.pitorque.de/MisterGoodcat/post/Silverlight-5-Tidbits-Trusted-applications.aspx
            注册表项如下：
            Key path for 32-bit computers: HKEY_LOCAL_MACHINE\Software\Microsoft\Silverlight\
            Key path for 64-bit computers: HKEY_LOCAL_MACHINE\Software\Wow6432Node\Microsoft\Silverlight\
            Value name: AllowElevatedTrustAppsInBrowser
            Value type: DWORD
            Valid Values:
            Disabled - 0x00000000
            Enabled - 0x00000001
            */


            string strPath = strFileDir + "\\" + fileName;
            //保存到我的文档中
            FileStream fso = new FileStream(strPath, FileMode.Create);
            while (l < imgLong)
            {
                int i = stream.Read(arrayByte, 0, 1024);
                fso.Write(arrayByte, 0, i);
                l += i;
            }

            fso.Close();
            stream.Close();  
        }
       
    }
}
